import { AccessInfo } from '../auth';
import { BaseModelSchemas, BaseModelQueryHandler, BaseModelMiddleware } from './model-middleware';
export declare type BaseModelBrowseArgs = {
    pagination?: BaseModelBrowsePagination;
    select?: any;
    where?: any;
    orderBy?: any;
    distinct?: any;
    take?: number;
    skip?: number;
    options?: BaseModelBrowseOptions;
};
export interface BaseModelBrowsePagination {
    pageSize?: number;
    page?: number;
}
export declare type BaseModelBrowseOptions = {
    speedMode?: boolean;
};
export declare type BaseModelBrowseReturn<T> = {
    items: T[];
    properties: BaseModelBrowsePagination | {
        count: number;
    };
};
export declare class BaseModel<T, PrismaClient, Model, BrowseArgs extends BaseModelBrowseArgs> {
    readonly schemas: BaseModelSchemas;
    readonly model: Model;
    private middleware;
    constructor(middleware: BaseModelMiddleware<PrismaClient>, name: string, schemas?: BaseModelSchemas);
    run<T>(accessInfo: AccessInfo, promise: BaseModelQueryHandler<T>): Promise<T>;
    browse(params?: BrowseArgs): Promise<BaseModelBrowseReturn<T>>;
    get client(): PrismaClient;
}
